--
--
-- DMEMORY module (provides the data memory for the SPIM computer)
library IEEE;
use IEEE.STD_LOGIC_1164.all;
library SYNTH;
use SYNTH.VHDLSYNTH.ALL;
--use SYNTH.VL_COMPS.ALL;

entity dmemory is

 
   port(rd_bus : out std_logic_vector(7 downto 0);
        ra_bus : in std_logic_vector(7 downto 0);
        wd_bus : in std_logic_vector(7 downto 0);
        wadd_bus : in std_logic_vector(7 downto 0);
        MemRead, Memwrite, MemtoReg : in std_logic;
                phi1,phi2,reset: in std_logic);

end dmemory;

--
-- DMEMORY architecture
--

architecture behavior of dmemory is
	  
          signal mem0,mem1,mem2,mem3,mem4,mem5,mem6,mem7 : std_logic_vector(7 downto 0);
          signal mux : std_logic_vector(7 downto 0);
          signal mem0write, mem1write : std_logic;


begin
-- Read Data Memory
with ra_bus(2 downto 0) select
mux <= mem0 WHEN "000",
	   mem1 WHEN "001",
	   mem2 WHEN "010",
	   mem3 WHEN "011",
	   mem4 WHEN "100",
	   mem5 WHEN "101",
	   mem6 WHEN "110",
           mem7 WHEN "111",
           To_stdlogicvector(X"FF") WHEN others;

-- Mux to skip data memory for Rformat instructions
rd_bus <= ra_bus(7 downto 0) WHEN (MemtoReg='0') ELSE mux WHEN (MemRead='1')
                ELSE To_Stdlogicvector(B"11111111");

-- Write to data memory?
-- The following code sets an initial value and replaces the next line
--dff_v(wd_bus,phi2 AND Memwrite AND (wadd_bus(2 downto 0)="000"),mem0);
mem0write <= '1' When ((Memwrite='1') AND(wadd_bus(2 downto 0)="000"))
              ELSE '0';
mem1write <= '1' When ((Memwrite='1') AND (wadd_bus(2 downto 0)="001"))
              ELSE '0';
process
begin   
wait until phi2'event and phi2='1';
   if (reset = '1') then
        mem0 <= To_stdlogicvector(X"55");
   else
   if mem0write= '1' then mem0 <= wd_bus; else mem0 <= mem0;
   end if;
   end if;
end process;

--dff_v(wd_bus,phi2 AND Memwrite AND (wadd_bus(2 downto 0)="001"),mem1);
process
begin   
wait until phi2'event AND phi2 = '1';
   if (reset = '1') then
        mem1 <= To_Stdlogicvector(X"AA");
   else
   if mem1write= '1' then mem1 <= wd_bus; else mem1 <= mem1;
   end if;
   end if;
end process;
mem2<= TO_Stdlogicvector(X"F2");
mem3<= TO_Stdlogicvector(X"F3");
mem4<= TO_Stdlogicvector(X"F4");
mem5<= TO_Stdlogicvector(X"F5");
mem6<= TO_Stdlogicvector(X"F6");
mem7<= TO_Stdlogicvector(X"F7");
end behavior;

